
clear
set mem 1000m

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"


use ppp_brazil
sort year
save ppp_brazil, replace

clear
use ExportValues
display _N

sort year
merge year using ppp_brazil
keep if _merge == 3
drop _merge
gen valueexpbrs = valueexpusd*xrat_bra / ppp_bra


keep cnpj pais ncm year valueexpbrs

**** Generate product ranking for each firm-destination-year triplet ****
gsort + cnpj + pais + year - valueexpbrs
by cnpj pais year: gen ranking = _n

* Time invariant ranking
preserve
keep cnpj pais ncm valueexpbrs
sort cnpj pais ncm
by cnpj pais ncm: egen totalvalue = total(valueexpbrs)
drop valueexpbrs
duplicates drop
gsort + cnpj + pais - totalvalue
by cnpj pais: gen ranking2 = _n
sort cnpj pais ncm
save ranking2, replace
restore

* Country invariant ranking
preserve
keep cnpj year ncm valueexpbrs
sort cnpj year ncm
by cnpj year ncm: egen totalvalue = total(valueexpbrs)
drop valueexpbrs
duplicates drop
gsort + cnpj + year - totalvalue
by cnpj year: gen ranking3 = _n
sort cnpj year ncm
save ranking3, replace
restore

* Country and time invariant ranking
preserve
keep cnpj ncm valueexpbrs
sort cnpj ncm
by cnpj ncm: egen totalvalue = total(valueexpbrs)
drop valueexpbrs
duplicates drop
gsort + cnpj - totalvalue
by cnpj: gen ranking4 = _n
sort cnpj ncm
save ranking4, replace
restore

display _N
sort cnpj pais ncm
merge cnpj pais ncm using ranking2
keep if _merge == 1 | _merge == 3
drop _merge

display _N
sort cnpj year ncm
merge cnpj year ncm using ranking3
keep if _merge == 1 | _merge == 3
drop _merge

display _N
sort cnpj ncm
merge cnpj ncm using ranking4
keep if _merge == 1 | _merge == 3
drop _merge

drop totalvalue

save ranking, replace
