
clear
set mem 1000m

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"

cap log close
log using "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results\SelectionEquation.log", replace

use years2
sort year
save years2, replace


clear
use group96_cnae2
rename group96 ncm
sort ncm
save group96cnae2, replace


clear
use RER2
sort country_isocode year
save RER2, replace


clear
use ranking
keep pais ncm cnpj ranking2
rename ranking2 ranking
duplicates drop
sort cnpj pais ncm
save ranking2, replace


clear
use cnpj_cnae9406
destring cnae, gen(cnaefirm)
rename cnpj8 cnpj
keep cnpj cnaefirm
sort cnpj cnaefirm
save cnpj_cnae, replace


use ppp_brazil
sort year
save ppp_brazil, replace


clear
use firms_lag
sort year
merge year using ppp_brazil
keep if _merge == 3
drop _merge
gen lag_imports = (lag_valorimpusd*xrat_bra) / (lag_wage*lag_emp*40*52)
replace lag_imports = 0 if lag_imports == .
gen lag_exports = (lag_valorexpusd*xrat_bra) / (lag_wage*lag_emp*40*52)
replace lag_exports = 0 if lag_exports == .
drop lag_valorimpusd lag_valorexpusd
sort cnpj year
save firms_lag_imp_exp, replace




clear
use ExportValues
display _N
sort cnpj 
merge cnpj using cnpj_cnae
keep if _merge == 1 | _merge == 3
drop _merge
display _N
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
display _N
keep cnpj pais country_isocode year numprod
duplicates drop
drop if cnpj == ""
display _N
sort cnpj pais year
save aux2, replace





clear
use ExportValues
sort cnpj 
merge cnpj using cnpj_cnae
keep if _merge == 1 | _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
keep cnpj cnaefirm pais country_isocode
duplicates drop
display _N
cross using years2
duplicates drop
display _N
drop if country_isocode == ""
sort cnpj pais year
merge cnpj pais year using aux2
keep if _merge == 3 | _merge == 1
drop _merge
display _N
replace numprod = 0 if numprod == .
drop if cnpj == "" | country_isocode == "" 
duplicates drop
display _N
sort cnpj year
gen aux = year
replace aux = 9999 if numprod == 0
sort cnpj pais
by cnpj pais: egen first_year = min(aux)
replace aux = 0 if numprod == 0
sort cnpj pais
by cnpj pais: egen last_year = max(aux)
keep if year >= first_year-1 & year <= last_year+1
display _N
drop aux 
keep first_year last_year pais country_isocode cnpj
duplicates drop
sort cnpj pais
save firms_period_active, replace


clear
use ExportValues
sort cnpj 
merge cnpj using cnpj_cnae
keep if _merge == 1 | _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
* Drop those products that changed classification in 2002
* drop if ncm <= 1000
keep ncm pais country_isocode cnpj
drop if ncm == . | pais == "" | country_isocode == "" | cnpj == ""
duplicates drop
cross using years2


duplicates drop
sort cnpj pais
display _N
merge cnpj pais using firms_period_active
keep if _merge == 3 | _merge == 1
drop _merge
display _N


sort cnpj year
merge cnpj year using firms_lag_imp_exp
keep if _merge == 3 | _merge == 1
drop _merge
display _N
drop if ncm == .
display _N
sort ncm pais cnpj year
save aux1, replace





clear
use ExportValues

keep ncm pais year cnpj valueexpusd
duplicates drop
sort ncm pais cnpj year
display _N
merge ncm pais cnpj year using aux1
drop _merge
display _N

sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3 | _merge == 1
drop _merge
display _N

sort ncm
merge ncm using ncm_cnae
keep if _merge == 3 | _merge == 1
drop _merge
display _N

sort ncm 
merge ncm using group96cnae2
keep if _merge == 1 | _merge == 3
drop _merge
replace cnaeprod = cnae2 if ncm <= 1000
drop cnae2
display _N

keep if year >= first_year-1 & year <= last_year

* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
* Drop those products that changed classification in 2002
* drop if ncm <= 1000


drop if ncm == . | pais == "" | year == . | cnpj == ""
replace  valueexpusd = 0 if  valueexpusd == .
gen active = ( valueexpusd > 0)
sort cnpj pais ncm year



preserve
keep cnpj pais ncm year active
replace year = year + 1
rename active lag_active
sort cnpj pais ncm year
save aux1, replace
restore


display _N
merge cnpj pais ncm year using aux1
keep if _merge == 3 | _merge == 1
drop _merge
display _N

keep if year >= max(first_year,1997) & year <= last_year
drop if lag_emp == .
display _N




sort country_isocode year
merge country_isocode year using RER2
keep if _merge == 3
drop _merge
duplicates drop
display _N


drop if active == . | ncm == . | country_isocode == "" | cnpj == ""
display _N


* Merging Comtrade data on imports at destinations
gen HS6 = ncm
replace HS6 = int(ncm / 100) if ncm > 1000
sort country_isocode HS6 year
merge country_isocode HS6 year using importsMinusBRA
keep if _merge ~= 2
drop _merge
gen log_demand = log(1+1000.0*importsMinusBRA)
replace log_demand = 0 if log_demand == .
display _N


gen log_rer         = log(rer)
gen log_lag_emp     = log(lag_emp)
gen log_cgdp        = log(cgdp)
gen log_lag_wage    = log(lag_wage)
gen log_lag_imports = log(1+lag_imports)
gen log_lag_exports = log(1+lag_exports)
gen log_gdp         = log(cgdp*pop)

display _N
sort cnpj pais ncm
merge cnpj pais ncm using ranking2
keep if _merge == 1 | _merge == 3
drop _merge
display _N


gen log_ranking_log_rer  = log(ranking)*log_rer
gen log_ranking2_log_rer = (log(ranking)^2)*log_rer
gen log_ranking3_log_rer = (log(ranking)^3)*log_rer
gen log_ranking4_log_rer = (log(ranking)^4)*log_rer
gen log_ranking5_log_rer = (log(ranking)^5)*log_rer

gen log_ranking  = log(ranking)
gen log_ranking2 = log(ranking)^2
gen log_ranking3 = log(ranking)^3
gen log_ranking4 = log(ranking)^4
gen log_ranking5 = log(ranking)^5



preserve
keep cnpj log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports year
duplicates drop
sort cnpj
by cnpj: egen m_log_emp = mean(log_lag_emp)
by cnpj: egen m_log_wage = mean(log_lag_wage)
by cnpj: egen m_skill = mean(lag_skill)
by cnpj: egen m_imp = mean(log_lag_imports)
by cnpj: egen m_exp = mean(log_lag_exports)
keep cnpj m_log_emp m_log_wage m_skill m_imp m_exp
duplicates drop
sort cnpj
save aux1, replace
restore

sort cnpj
merge cnpj using aux1
keep if _merge == 3
drop _merge
display _N


preserve
keep country_isocode year log_cgdp log_gdp log_rer
duplicates drop
sort country_isocode
by country_isocode: egen m_log_cgdp = mean(log_cgdp)
by country_isocode: egen m_log_gdp = mean(log_gdp)
by country_isocode: egen m_log_rer = mean(log_rer)
keep country_isocode m_log_cgdp m_log_gdp m_log_rer
duplicates drop
sort country_isocode
save aux1, replace
restore

sort country_isocode
merge country_isocode using aux1
keep if _merge == 3
drop _merge
duplicates drop
display _N


preserve
keep HS6 country_isocode year log_demand
duplicates drop
sort HS6 country_isocode
by HS6 country_isocode: egen m_log_dem = mean(log_demand)
keep HS6 country_isocode m_log_dem
duplicates drop 
sort HS6 country_isocode
save aux1, replace
restore


display _N
sort HS6 country_isocode
merge HS6 country_isocode using aux1
keep if _merge == 3 | _merge == 1
drop _merge
display _N


qui tab year, gen(yearFE)	 
qui tab cnaefirm, gen(cnaeFE)
qui tab pais, gen(countryFE)

keep active cnaeFE* countryFE* yearFE* lag_active log_rer log_ranking_log_rer log_ranking2_log_rer log_ranking3_log_rer ///
     log_ranking4_log_rer log_ranking5_log_rer ///
     log_lag_emp lag_skill log_lag_wage log_lag_imports log_lag_exp ///
	 log_ranking log_ranking2 log_ranking3 log_ranking4 log_ranking5 log_cgdp log_gdp log_demand ///
	 ncm cnpj pais year ///
	 m_log_emp m_log_wage m_skill m_imp m_exp m_log_dem m_log_cgdp m_log_gdp m_log_rer

gen var1   = m_log_emp
gen var2   = m_log_wage
gen var3   = m_skill
gen var4   = m_imp
gen var5   = m_exp
gen var6   = m_log_dem
gen var7   = log_ranking
gen var8   = m_log_rer
gen var9   = m_log_cgdp
gen var10  = m_log_gdp

local n = 0
forvalues i = 1(1)10{
	forvalues j = `i'(1)10{
		local n = `n' + 1
		qui gen inter`n' = var`i'*var`j'
	}
}	


gen t1 = year - 1997
gen t2 = (year - 1997)^2
gen t3 = (year - 1997)^3
gen t4 = (year - 1997)^4
gen t5 = (year - 1997)^5

save IMR_Probit_File, replace

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results"

qui probit    active cnaeFE* yearFE* countryFE* m_log_emp m_log_wage m_skill m_imp m_exp m_log_dem ///
              lag_active log_rer log_ranking_log_rer log_ranking2_log_rer log_ranking3_log_rer ///
              log_ranking4_log_rer log_ranking5_log_rer ///
              log_lag_emp lag_skill log_lag_wage log_lag_imports log_lag_exports log_cgdp log_gdp log_demand ///
		      log_ranking log_ranking2 log_ranking3 log_ranking4 log_ranking5 inter1-inter55
qui outreg2   cnaeFE* yearFE* countryFE* m_log_emp m_log_wage m_skill m_imp m_exp m_log_dem ///
              lag_active log_rer log_ranking_log_rer log_ranking2_log_rer log_ranking3_log_rer ///
              log_ranking4_log_rer log_ranking5_log_rer ///
              log_lag_emp lag_skill log_lag_wage log_lag_imports log_lag_exports log_cgdp log_gdp log_demand ///
		      log_ranking log_ranking2 log_ranking3 log_ranking4 log_ranking5 inter1-inter55 using SelectionEquation, replace excel bdec(4) bracket ctitle("IMR")	

predict PROBITXB, xb
gen PDFPROBIT = normalden(PROBITXB)
gen CDFPROBIT = normal(PROBITXB)
gen IMR = PDFPROBIT/CDFPROBIT

display _N
drop if IMR == .
display _N

keep ncm cnpj pais year IMR 
duplicates drop
display _N

sort ncm cnpj pais year IMR 

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"

save IMR, replace

log close

