
clear
set mem 1000m

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"

cap log close
log using "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results\SelectionEquation2.log", replace



clear
use years2
sort year
save years2, replace


clear
use RER2
sort country_isocode year
save RER2, replace


clear
use cnpj_cnae9406
destring cnae, gen(cnaefirm)
rename cnpj8 cnpj
keep cnpj cnaefirm
sort cnpj cnaefirm
save cnpj_cnae, replace


use ppp_brazil
sort year
save ppp_brazil, replace


clear
use firms_lag
sort year
merge year using ppp_brazil
keep if _merge == 3
drop _merge
gen lag_imports = (lag_valorimpusd*xrat_bra) / (lag_wage*lag_emp*40*52)
replace lag_imports = 0 if lag_imports == .
gen lag_exports = (lag_valorexpusd*xrat_bra) / (lag_wage*lag_emp*40*52)
replace lag_exports = 0 if lag_exports == .
drop lag_valorimpusd lag_valorexpusd
sort cnpj year
save firms_lag_imp_exp, replace




clear
use ExportValues
display _N
sort cnpj 
merge cnpj using cnpj_cnae
keep if _merge == 1 | _merge == 3
drop _merge
display _N
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
display _N
keep cnpj pais country_isocode year numprod
duplicates drop
drop if cnpj == ""
display _N
sort cnpj pais year
save aux2, replace





clear
use ExportValues
sort cnpj 
merge cnpj using cnpj_cnae
keep if _merge == 1 | _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
keep cnpj cnaefirm pais country_isocode
duplicates drop
display _N
cross using years2
duplicates drop
display _N
drop if country_isocode == ""
sort cnpj pais year
merge cnpj pais year using aux2
keep if _merge == 3 | _merge == 1
drop _merge
display _N
replace numprod = 0 if numprod == .
drop if cnpj == "" | country_isocode == "" 
duplicates drop
display _N
sort cnpj year
gen aux = year
replace aux = 9999 if numprod == 0
sort cnpj pais
by cnpj pais: egen first_year = min(aux)
replace aux = 0 if numprod == 0
sort cnpj pais
by cnpj pais: egen last_year = max(aux)
keep if year >= first_year-1 & year <= last_year+1
display _N
drop aux 
gen multi = (numprod > 1)
gen active = (numprod > 0)
sort cnpj pais
by cnpj pais: egen max_prod = max(numprod)
sort cnpj pais year
gen mpf = (max_prod > 1)
sort cnpj pais year

preserve
keep cnpj pais year multi active numprod
replace year = year + 1
keep if year <= 2006 & year >= 1997
rename multi lag_multi
rename numprod lag_numprod
rename active lag_active
sort cnpj pais year
save aux1, replace
restore

display _N
merge cnpj pais year using aux1
keep if _merge == 3 | _merge == 1
drop _merge
display _N

keep if year >= max(first_year,1997) & year <= last_year
display _N

sort country_isocode year
merge country_isocode year using RER2
keep if _merge == 3
drop _merge
duplicates drop
display _N


sort cnpj year
merge cnpj year using firms_lag_imp_exp
keep if _merge == 3 | _merge == 1
drop _merge
display _N



drop if multi == . | country_isocode == "" | cnpj == ""
display _N


gen log_rer         = log(rer)
gen log_lag_emp     = log(lag_emp)
gen log_cgdp        = log(cgdp)
gen log_lag_wage    = log(lag_wage)
gen log_lag_imports = log(1+lag_imports)
gen log_lag_exports = log(1+lag_exports)
gen log_gdp         = log(cgdp*pop)
gen log_lag_numprod = log(lag_numprod)

gen log_rer_emp    = log_rer*log_lag_emp
gen log_rer_skill  = log_rer*lag_skill
gen log_rer_wage   = log_rer*log_lag_wage
gen log_rer_imp    = log_rer*log_lag_imports
gen log_rer_exp    = log_rer*log_lag_exports


preserve
keep cnpj log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports year
duplicates drop
sort cnpj
by cnpj: egen m_log_emp = mean(log_lag_emp)
by cnpj: egen m_log_wage = mean(log_lag_wage)
by cnpj: egen m_skill = mean(lag_skill)
by cnpj: egen m_imp = mean(log_lag_imports)
by cnpj: egen m_exp = mean(log_lag_exports)
keep cnpj m_log_emp m_log_wage m_skill m_imp m_exp
duplicates drop
sort cnpj
save aux1, replace
restore

sort cnpj
merge cnpj using aux1
keep if _merge == 3
drop _merge
display _N


preserve
keep country_isocode year log_cgdp log_gdp log_rer
duplicates drop
sort country_isocode
by country_isocode: egen m_log_cgdp = mean(log_cgdp)
by country_isocode: egen m_log_gdp = mean(log_gdp)
by country_isocode: egen m_log_rer = mean(log_rer)
keep country_isocode m_log_cgdp m_log_gdp m_log_rer
duplicates drop
sort country_isocode
save aux1, replace
restore

sort country_isocode
merge country_isocode using aux1
keep if _merge == 3
drop _merge
duplicates drop
display _N




keep cnaefirm pais cnpj multi year m_log_emp m_log_wage m_skill m_imp m_exp  /// 
     lag_multi log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp ///
	 mpf m_log_cgdp m_log_gdp m_log_rer year active lag_active log_lag_numprod


qui tab year, gen(yearFE)	 
qui tab cnaefirm, gen(cnaeFE)
qui tab pais, gen(countryFE)

gen var1   = m_log_emp
gen var2   = m_log_wage
gen var3   = m_skill
gen var4   = m_imp
gen var5   = m_exp
gen var6   = m_log_rer
gen var7   = m_log_cgdp
gen var8   = m_log_gdp

local n = 0
forvalues i = 1(1)8{
	forvalues j = `i'(1)8{
		local n = `n' + 1
		qui gen inter`n' = var`i'*var`j'
	}
}	

gen t1 = year - 1997
gen t2 = (year - 1997)^2
gen t3 = (year - 1997)^3
gen t4 = (year - 1997)^4
gen t5 = (year - 1997)^5

save Skewness_Probit_File, replace

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results"

qui probit multi t1-t5 countryFE* cnaeFE* m_log_emp m_log_wage m_skill m_imp m_exp /// 
              lag_multi log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp ///
			  inter1-inter36 if mpf == 1
qui outreg2   t1-t5 countryFE* cnaeFE* m_log_emp m_log_wage m_skill m_imp m_exp /// 
              lag_multi log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp ///
			  inter1-inter36 using SelectionEquation2, replace excel bdec(4) bracket ctitle("IMR")	

predict PROBITXB, xb
gen PDFPROBIT = normalden(PROBITXB)
gen CDFPROBIT = normal(PROBITXB)
gen IMR = PDFPROBIT/CDFPROBIT

display _N
drop if IMR == .
display _N

keep if mpf == 1

keep cnpj pais year IMR 
sort cnpj pais year IMR
duplicates drop
sort cnpj pais year IMR

display _N

save IMRSkewness1, replace



clear

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"

use Skewness_Probit_File

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results"

qui probit active t1-t5 countryFE* cnaeFE* m_log_emp m_log_wage m_skill m_imp m_exp /// 
              lag_active log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp ///
			  inter1-inter36
qui outreg2   t1-t5 countryFE* cnaeFE* m_log_emp m_log_wage m_skill m_imp m_exp /// 
              lag_active log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp ///
			  inter1-inter36 using SelectionEquation2, append excel bdec(4) bracket ctitle("IMR")	

predict PROBITXB, xb
gen PDFPROBIT = normalden(PROBITXB)
gen CDFPROBIT = normal(PROBITXB)
gen IMR = PDFPROBIT/CDFPROBIT

display _N
drop if IMR == .
display _N

keep cnpj pais year IMR 
sort cnpj pais year IMR
duplicates drop
sort cnpj pais year IMR

display _N

save IMRSkewness2, replace

log close
