clear
set mem 700m


cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"

clear
use RER2
sort country_isocode year
save RER2, replace


clear
use RER2
rename rer lag_rer
replace year = year + 1
sort country_isocode year
save lag_RER, replace



clear
use cnpj_cnae9406
destring cnae, gen(cnaefirm)
rename cnpj8 cnpj
keep cnpj cnaefirm
sort cnpj cnaefirm
save cnpj_cnae, replace





clear
use ExportValues
sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if year >= 1997
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
keep cnpj pais country_isocode year numprod
duplicates drop
sort cnpj pais year
save aux2, replace




clear
use Exportvalues
sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if year >= 1997
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
keep cnpj pais country_isocode cnaefirm
duplicates drop
drop if cnpj == "" | country_isocode == ""
cross using years
sort cnpj pais year
merge cnpj pais year using aux2
keep if _merge == 3 | _merge == 1
drop _merge
replace numprod = 0 if numprod == .
sort cnpj year
gen aux = year
replace aux = 9999 if numprod == 0
sort cnpj pais
by cnpj pais: egen first_year = min(aux)
replace aux = 0 if numprod == 0
sort cnpj pais
by cnpj pais: egen last_year = max(aux)
drop aux 
sort cnpj pais year


preserve
replace year = year + 1
rename numprod lag_numprod
sort cnpj pais year
save aux1, replace
restore


merge cnpj pais year using aux1
keep if _merge == 3
drop _merge

keep if year >= first_year - 1 & year <= last_year + 1



sort country_isocode year
merge country_isocode year using RER2
keep if _merge == 3
drop _merge


sort country_isocode year
merge country_isocode year using lag_RER
keep if _merge == 3
drop _merge





gen delta_num_prod  = log(1+numprod) - log(1+lag_numprod)
gen log_rer = log(rer)
gen lag_log_rer = log(lag_rer)
gen delta_log_rer = log_rer - lag_log_rer

tab year, gen(yearFE)

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results"

reg delta_num_prod yearFE* delta_log_rer
matrix coef = e(b)
gen delta_np = delta_num_prod - coef[1,1]*yearFE1 - coef[1,2]*yearFE2 - coef[1,3]*yearFE3 - coef[1,4]*yearFE4 - coef[1,5]*yearFE5 - coef[1,6]*yearFE6 - ///
coef[1,7]*yearFE7 - coef[1,9]


preserve

keep country_isocode delta_log_rer year
duplicates drop

xtile decile_delta_log_rer = delta_log_rer, nq(10)

keep country_isocode year decile_delta_log_rer
duplicates drop

sort country_isocode year

save aux1, replace

restore


sort country_isocode year
merge country_isocode year using aux1
keep if _merge == 3
drop _merge


tab decile_delta_log_rer, gen(decile)
reg delta_num_prod yearFE2-yearFE7 decile1-decile4 decile6-decile10
outreg2 decile1-decile4 decile6-decile10 using Rawgraph, replace excel bdec(4) noaster


