clear
set mem 700m


cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"

clear
use RER2
sort country_isocode year
save RER2, replace


clear
use cnpj_cnae9406
destring cnae, gen(cnaefirm)
rename cnpj8 cnpj
keep cnpj cnaefirm
sort cnpj cnaefirm
save cnpj_cnae, replace


clear
use firms_lag
sort year
merge year using ppp_brazil
keep if _merge == 3
drop _merge
gen lag_imports = (lag_valorimpusd*xrat_bra) / (lag_wage*lag_emp*40*52)
replace lag_imports = 0 if lag_imports == .
gen lag_exports = (lag_valorexpusd*xrat_bra) / (lag_wage*lag_emp*40*52)
replace lag_exports = 0 if lag_exports == .
drop lag_valorimpusd lag_valorexpusd
sort cnpj year
save firms_lag_imp_exp, replace




use ExportValues
sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if year >= 1997
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
keep cnpj 
duplicates drop
sort cnpj
merge cnpj using firms_lag_imp_exp
keep if _merge == 3 | _merge == 1
drop _merge
duplicates drop
sort cnpj year
save aux1, replace




clear
use ExportValues
sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if year >= 1997
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
keep cnpj pais country_isocode year numprod
duplicates drop
sort cnpj pais year
save aux2, replace




clear
use Exportvalues
sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if year >= 1997
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
keep cnpj pais country_isocode cnaefirm
duplicates drop
drop if cnpj == "" | country_isocode == ""
cross using years
sort cnpj pais year
merge cnpj pais year using aux2
keep if _merge == 3 | _merge == 1
drop _merge
replace numprod = 0 if numprod == .
sort cnpj year
gen aux = year
replace aux = 9999 if numprod == 0
sort cnpj pais
by cnpj pais: egen first_year = min(aux)
replace aux = 0 if numprod == 0
sort cnpj pais
by cnpj pais: egen last_year = max(aux)
keep if year >= first_year & year <= last_year
drop aux first_year last_year aux
sort year pais
save num_prod, replace




clear
use Exportvalues
sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if year >= 1997
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
sort country_isocode year
merge country_isocode year using RER2
keep if _merge == 3
keep year pais country_isocode rer cgdp pop
sort year pais
duplicates drop
merge year pais using num_prod
keep if _merge == 3 | _merge == 1
drop _merge
duplicates drop
sort cnpj year
merge cnpj year using aux1
keep if _merge == 3 | _merge == 1
drop _merge



gen log_rer         = log(rer)
gen log_lag_emp     = log(lag_emp)
gen log_cgdp        = log(cgdp)
gen log_gdp         = log(cgdp*pop)
gen log_lag_wage    = log(lag_wage)
gen log_lag_imports = log(1+lag_imports)
gen log_lag_exports = log(1+lag_exports)
gen log_num_prod    = log(1+numprod)

gen log_rer_emp    = log_rer*log_lag_emp
gen log_rer_skill  = log_rer*lag_skill
gen log_rer_wage   = log_rer*log_lag_wage
gen log_rer_imp    = log_rer*log_lag_imports
gen log_rer_exp    = log_rer*log_lag_exports

gen t1 = year - 1997
gen t2 = (year - 1997)^2
gen t3 = (year - 1997)^3
gen t4 = (year - 1997)^4
gen t5 = (year - 1997)^5


sort cnpj pais
duplicates drop
egen gp = group(cnpj pais)



preserve
keep cnpj log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports year
duplicates drop
sort cnpj
by cnpj: egen m_log_emp = mean(log_lag_emp)
by cnpj: egen m_log_wage = mean(log_lag_wage)
by cnpj: egen m_skill = mean(lag_skill)
by cnpj: egen m_imp = mean(log_lag_imports)
by cnpj: egen m_exp = mean(log_lag_exports)
keep cnpj m_log_emp m_log_wage m_skill m_imp m_exp
duplicates drop
sort cnpj
save aux1, replace
restore

sort cnpj
merge cnpj using aux1
keep if _merge == 3 | _merge == 1
drop _merge


preserve
keep country_isocode year log_cgdp log_gdp log_rer
duplicates drop
sort country_isocode
by country_isocode: egen m_log_cgdp = mean(log_cgdp)
by country_isocode: egen m_log_gdp = mean(log_gdp)
by country_isocode: egen m_log_rer = mean(log_rer)
keep country_isocode m_log_cgdp m_log_gdp m_log_rer
duplicates drop
sort country_isocode
save aux1, replace
restore

sort country_isocode
merge country_isocode using aux1
keep if _merge == 3 | _merge == 1
drop _merge


preserve
keep country_isocode cnpj year log_rer_emp log_rer_imp log_rer_exp log_rer_skill log_rer_wage
duplicates drop
sort country_isocode cnpj
by country_isocode cnpj: egen m_log_rer_emp = mean(log_rer_emp)
by country_isocode cnpj: egen m_log_rer_imp = mean(log_rer_imp)
by country_isocode cnpj: egen m_log_rer_exp = mean(log_rer_exp)
by country_isocode cnpj: egen m_log_rer_skill = mean(log_rer_skill)
by country_isocode cnpj: egen m_log_rer_wage = mean(log_rer_wage)
keep country_isocode cnpj m_log_rer_emp m_log_rer_imp m_log_rer_exp m_log_rer_skill m_log_rer_wage
duplicates drop 
sort country_isocode cnpj
save aux1, replace
restore

sort country_isocode cnpj
merge country_isocode cnpj using aux1
keep if _merge == 3 | _merge == 1
drop _merge


qui tab year, gen(yearFE)	
qui tab pais, gen(countryFE)	
qui tab cnaefirm, gen(cnaeFE)

keep log_num_prod numprod yearFE* countryFE* cnaeFE* log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp cnpj ///
     log_rer_emp log_rer_skill log_rer_wage log_rer_imp log_rer_exp ///
	 m_log_rer_emp m_log_rer_imp m_log_rer_exp m_log_rer_skill m_log_rer_wage ///
	 m_log_emp m_log_wage m_skill m_imp m_exp m_log_cgdp m_log_gdp m_log_rer gp t1 t2 t3 t4 t5
	 
	 
	 
gen var1 = m_log_emp
gen var2 = m_log_wage
gen var3 = m_skill
gen var4 = m_imp
gen var5 = m_exp
gen var6 = m_log_cgdp
gen var7 = m_log_gdp
gen var8 = m_log_rer

local n = 0
forvalues i = 1(1)8{
	forvalues j = `i'(1)8{
		local n = `n' + 1
		qui gen inter`n' = var`i'*var`j'
	}
}	


cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results"

qui areg log_num_prod t1 t2 t3 t4 t5 log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp, absorb(gp) vce(cluster cnpj) 
qui outreg2 log_rer log_lag_emp lag_skill log_lag_wage log_lag_imports log_lag_exports log_cgdp log_gdp using NProducts, replace excel bdec(4) bracket ctitle("OLS w/ FE")

qui reg log_num_prod t1 t2 t3 t4 t5 countryFE* cnaeFE* m_log_emp m_log_wage m_skill m_imp m_exp ///
log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp inter1-inter36, vce(cluster cnpj) 
qui outreg2 log_rer log_lag_emp lag_skill log_lag_wage log_lag_imports log_lag_exports log_cgdp log_gdp using NProducts, append excel bdec(4) bracket ctitle("OLS wo/ FE")
	 
qui tobit log_num_prod t1 t2 t3 t4 t5 countryFE* cnaeFE* m_log_emp m_log_wage m_skill m_imp m_exp ///
log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp inter1-inter36, ll(0) vce(cluster cnpj) 
qui outreg2 log_rer log_lag_emp lag_skill log_lag_wage log_lag_imports log_lag_exports log_cgdp log_gdp using NProducts, append excel bdec(4) bracket ctitle("Tobit")


qui areg log_num_prod t1 t2 t3 t4 t5 log_rer log_rer_emp log_rer_skill log_rer_wage log_rer_imp log_rer_exp   ///
log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp, absorb(gp) vce(cluster cnpj) 
qui outreg2 log_rer log_rer_emp log_rer_skill log_rer_wage log_rer_imp log_rer_exp   ///
log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp using NProductsInter, replace excel bdec(4) bracket ctitle("OLS w/ FE w/ Interactions")

qui reg log_num_prod t1 t2 t3 t4 t5 countryFE* cnaeFE* m_log_emp m_log_wage m_skill m_imp m_exp ///
log_rer log_rer_emp log_rer_skill log_rer_wage log_rer_imp log_rer_exp  ///
log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp inter1-inter36, vce(cluster cnpj) 
qui outreg2 log_rer log_rer_emp log_rer_skill log_rer_wage log_rer_imp log_rer_exp   ///
log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp using NProductsInter, append excel bdec(4) bracket ctitle("OLS wo/ FE w/ Interactions")

qui tobit log_num_prod t1 t2 t3 t4 t5 countryFE* cnaeFE* m_log_emp m_log_wage m_skill m_imp m_exp ///
log_rer log_rer_emp log_rer_skill log_rer_wage log_rer_imp log_rer_exp   ///
log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp inter1-inter36, ll(0) vce(cluster cnpj) 
qui outreg2 log_rer log_rer_emp log_rer_skill log_rer_wage log_rer_imp log_rer_exp   ///
log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp using NProductsInter, append excel bdec(4) bracket ctitle("Tobit w/ Interactions")


















cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"

clear
use RER2
sort country_isocode year
save RER2, replace


clear
use cnpj_cnae9406
destring cnae, gen(cnaefirm)
rename cnpj8 cnpj
keep cnpj cnaefirm
sort cnpj cnaefirm
save cnpj_cnae, replace


clear
use firms_lag
sort year
merge year using ppp_brazil
keep if _merge == 3
drop _merge
gen lag_imports = (lag_valorimpusd*xrat_bra) / (lag_wage*lag_emp*40*52)
replace lag_imports = 0 if lag_imports == .
gen lag_exports = (lag_valorexpusd*xrat_bra) / (lag_wage*lag_emp*40*52)
replace lag_exports = 0 if lag_exports == .
drop lag_valorimpusd lag_valorexpusd
sort cnpj year
save firms_lag_imp_exp, replace




use ExportValues
sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if year >= 1997
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
keep cnpj 
duplicates drop
sort cnpj
merge cnpj using firms_lag_imp_exp
keep if _merge == 3 | _merge == 1
drop _merge
duplicates drop
sort cnpj year
save aux1, replace




clear
use ExportValues
sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if year >= 1997
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
keep cnpj pais country_isocode year numprod
duplicates drop
sort cnpj pais year
save aux2, replace




clear
use Exportvalues
sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if year >= 1997
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
keep cnpj pais country_isocode cnaefirm
duplicates drop
drop if cnpj == "" | country_isocode == ""
cross using years
sort cnpj pais year
merge cnpj pais year using aux2
keep if _merge == 3 | _merge == 1
drop _merge
replace numprod = 0 if numprod == .
sort cnpj year
gen aux = year
replace aux = 9999 if numprod == 0
sort cnpj pais
by cnpj pais: egen first_year = min(aux)
replace aux = 0 if numprod == 0
sort cnpj pais
by cnpj pais: egen last_year = max(aux)
keep if year >= first_year & year <= last_year
drop aux first_year last_year aux
sort year pais
save num_prod, replace




clear
use Exportvalues
sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if year >= 1997
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
*drop if ncm <= 1000
sort country_isocode year
merge country_isocode year using RER2
keep if _merge == 3
keep year pais country_isocode rer cgdp pop
sort year pais
duplicates drop
merge year pais using num_prod
keep if _merge == 3 | _merge == 1
drop _merge
duplicates drop
sort cnpj year
merge cnpj year using aux1
keep if _merge == 3 | _merge == 1
drop _merge

egen gp = group(cnpj pais)

gen log_rer       = log(rer)
gen log_lag_emp   = log(lag_emp)
gen log_cgdp      = log(cgdp)
gen log_gdp      = log(cgdp*pop)
gen log_lag_wage  = log(lag_wage)
gen log_lag_imports = log(1+lag_imports)
gen log_lag_exports = log(1+lag_exports)
gen log_num_prod  = log(1+numprod)

gen log_rer_emp    = log_rer*log_lag_emp
gen log_rer_skill  = log_rer*lag_skill
gen log_rer_wage   = log_rer*log_lag_wage
gen log_rer_imp    = log_rer*log_lag_imports
gen log_rer_exp    = log_rer*log_lag_exports

gen t1 = year - 1997
gen t2 = (year - 1997)^2
gen t3 = (year - 1997)^3
gen t4 = (year - 1997)^4
gen t5 = (year - 1997)^5

sort cnpj pais

save aux1, replace



keep cnpj pais year
duplicates drop

gen ones = 1

sort cnpj pais
by cnpj pais: egen totobs = sum(ones)
by cnpj pais: egen first_year = min(year)
by cnpj pais: egen last_year = max(year)

gen connected = 0

replace connected = 1 if first_year == 1997 & last_year == 1998 & totobs== 2
replace connected = 1 if first_year == 1997 & last_year == 1999 & totobs== 3
replace connected = 1 if first_year == 1997 & last_year == 2000 & totobs== 4
replace connected = 1 if first_year == 1997 & last_year == 2001 & totobs== 5
replace connected = 1 if first_year == 1997 & last_year == 2002 & totobs== 6
replace connected = 1 if first_year == 1997 & last_year == 2003 & totobs== 7
replace connected = 1 if first_year == 1997 & last_year == 2004 & totobs== 8
replace connected = 1 if first_year == 1997 & last_year == 2005 & totobs== 9
replace connected = 1 if first_year == 1997 & last_year == 2006 & totobs== 10

replace connected = 1 if first_year == 1998 & last_year == 1999 & totobs== 2
replace connected = 1 if first_year == 1998 & last_year == 2000 & totobs== 3
replace connected = 1 if first_year == 1998 & last_year == 2001 & totobs== 4
replace connected = 1 if first_year == 1998 & last_year == 2002 & totobs== 5
replace connected = 1 if first_year == 1998 & last_year == 2003 & totobs== 6
replace connected = 1 if first_year == 1998 & last_year == 2004 & totobs== 7
replace connected = 1 if first_year == 1998 & last_year == 2005 & totobs== 8
replace connected = 1 if first_year == 1998 & last_year == 2006 & totobs== 9

replace connected = 1 if first_year == 1999 & last_year == 2000 & totobs== 2
replace connected = 1 if first_year == 1999 & last_year == 2001 & totobs== 3
replace connected = 1 if first_year == 1999 & last_year == 2002 & totobs== 4
replace connected = 1 if first_year == 1999 & last_year == 2003 & totobs== 5
replace connected = 1 if first_year == 1999 & last_year == 2004 & totobs== 6
replace connected = 1 if first_year == 1999 & last_year == 2005 & totobs== 7
replace connected = 1 if first_year == 1999 & last_year == 2006 & totobs== 8

replace connected = 1 if first_year == 2000 & last_year == 2001 & totobs== 2
replace connected = 1 if first_year == 2000 & last_year == 2002 & totobs== 3
replace connected = 1 if first_year == 2000 & last_year == 2003 & totobs== 4
replace connected = 1 if first_year == 2000 & last_year == 2004 & totobs== 5
replace connected = 1 if first_year == 2000 & last_year == 2005 & totobs== 6
replace connected = 1 if first_year == 2000 & last_year == 2006 & totobs== 7

replace connected = 1 if first_year == 2001 & last_year == 2002 & totobs== 2
replace connected = 1 if first_year == 2001 & last_year == 2003 & totobs== 3
replace connected = 1 if first_year == 2001 & last_year == 2004 & totobs== 4
replace connected = 1 if first_year == 2001 & last_year == 2005 & totobs== 5
replace connected = 1 if first_year == 2001 & last_year == 2006 & totobs== 6

replace connected = 1 if first_year == 2002 & last_year == 2003 & totobs== 2
replace connected = 1 if first_year == 2002 & last_year == 2004 & totobs== 3
replace connected = 1 if first_year == 2002 & last_year == 2005 & totobs== 4
replace connected = 1 if first_year == 2002 & last_year == 2006 & totobs== 5

replace connected = 1 if first_year == 2003 & last_year == 2004 & totobs== 2
replace connected = 1 if first_year == 2003 & last_year == 2005 & totobs== 3
replace connected = 1 if first_year == 2003 & last_year == 2006 & totobs== 4

replace connected = 1 if first_year == 2004 & last_year == 2005 & totobs== 2
replace connected = 1 if first_year == 2004 & last_year == 2006 & totobs== 3

replace connected = 1 if first_year == 2005 & last_year == 2006 & totobs== 2


keep if connected == 1

duplicates drop

sort cnpj pais

merge cnpj pais using aux1
keep if _merge == 3 | _merge == 1
drop _merge

replace connected = 0 if connected == .


keep gp log_num_prod numprod log_rer t1 t2 t3 t4 t5 log_lag_emp lag_skill log_lag_wage log_lag_imports log_lag_exports log_cgdp connected totobs cnpj ///
     log_rer log_rer_emp log_rer_skill log_rer_wage log_rer_imp log_rer_exp pais log_gdp cnaefirm
duplicates drop

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results"

qui areg log_num_prod log_rer t1 t2 t3 t4 t5 log_lag_emp lag_skill log_lag_wage log_lag_imports log_lag_exports log_cgdp log_gdp  if totobs == 10, absorb(gp) vce(cluster cnpj)
qui outreg2 log_rer log_lag_emp lag_skill log_lag_wage log_lag_imports log_lag_exports log_cgdp log_gdp using NProducts, append excel bdec(4) bracket ctitle("NProducts Always There")

qui areg log_num_prod log_rer log_rer_emp log_rer_skill log_rer_wage log_rer_imp log_rer_exp   ///
    t1 t2 t3 t4 t5 log_lag_emp lag_skill log_lag_wage log_lag_imports log_lag_exports log_cgdp log_gdp if totobs == 10, absorb(gp) vce(cluster cnpj)
qui outreg2 log_rer log_rer log_rer_emp log_rer_skill log_rer_wage log_rer_imp log_rer_exp    ///
    log_lag_emp lag_skill log_lag_wage log_lag_imports log_lag_exports log_cgdp log_gdp using NProductsInter, append excel bdec(4) bracket ctitle("NProducts Always There")


