clear
set mem 700m

cap log close

log using DescriptiveStats, replace

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"




use UnitValues_Firms_RER

*********************
* Importance of MPF's
*********************

replace cnaeprod = cnaefirm if cnaeprod == .
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37

* drop if ncm <= 1000

gen mpf = (num_prod > 1)

duplicates drop

tab mpf, matcell(matrix1)

preserve

keep cnpj pais total_emp valoragg num_prod year

sort cnpj pais year
by cnpj pais year: egen sum_valor = total(valoragg)

keep cnpj pais year num_prod total_emp sum_valor

duplicates drop

gen mpf = (num_prod > 1)

tab mpf, matcell(matrix2)

tab mpf [iw = total_emp], matcell(matrix3)

tab mpf [iw = sum_valor], matcell(matrix4)

restore

matrix matrix_mpf = J(2,4,0)

matrix matrix_mpf[1,1]=matrix1[1,1]/(matrix1[1,1]+matrix1[2,1])
matrix matrix_mpf[2,1]=matrix1[2,1]/(matrix1[1,1]+matrix1[2,1])

matrix matrix_mpf[1,2]=matrix2[1,1]/(matrix2[1,1]+matrix2[2,1])
matrix matrix_mpf[2,2]=matrix2[2,1]/(matrix2[1,1]+matrix2[2,1])

matrix matrix_mpf[1,3]=matrix3[1,1]/(matrix3[1,1]+matrix3[2,1])
matrix matrix_mpf[2,3]=matrix3[2,1]/(matrix3[1,1]+matrix3[2,1])

matrix matrix_mpf[1,4]=matrix4[1,1]/(matrix4[1,1]+matrix4[2,1])
matrix matrix_mpf[2,4]=matrix4[2,1]/(matrix4[1,1]+matrix4[2,1])



******************
* Top industries
******************
clear

use ppp_brazil
sort year
save ppp_brazil, replace

use ExportValues

sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37

sort year
merge year using ppp_brazil
keep if _merge == 3
drop _merge
gen valueexpbrs = valueexpusd*xrat_bra / ppp_bra

keep cnaeprod valueexpbrs

sort cnaeprod

by cnaeprod: egen tot_valor = total(valueexpbrs)

egen grand_total = total(valueexpbrs)

gen fraction = tot_valor / grand_total

keep cnaeprod fraction

duplicates drop

gsort - fraction

list



************************************
* Mean and Median Number of Products
************************************
clear

use ExportValues

sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37

keep cnpj pais numprod cnaefirm
duplicates drop

matrix Num_Prod_CNAE = J(11,4,0)

* Top Industries
sum numprod if cnaefirm == 15, detail
matrix Num_Prod_CNAE[1,1] = 15
matrix Num_Prod_CNAE[1,2] = r(mean)
matrix Num_Prod_CNAE[1,3] = r(p50)
matrix Num_Prod_CNAE[1,4] = r(max)

sum numprod if cnaefirm == 27, detail
matrix Num_Prod_CNAE[2,1] = 27
matrix Num_Prod_CNAE[2,2] = r(mean)
matrix Num_Prod_CNAE[2,3] = r(p50)
matrix Num_Prod_CNAE[2,4] = r(max)

sum numprod if cnaefirm == 29, detail
matrix Num_Prod_CNAE[3,1] = 29
matrix Num_Prod_CNAE[3,2] = r(mean)
matrix Num_Prod_CNAE[3,3] = r(p50)
matrix Num_Prod_CNAE[3,4] = r(max)

sum numprod if cnaefirm == 24, detail
matrix Num_Prod_CNAE[4,1] = 24
matrix Num_Prod_CNAE[4,2] = r(mean)
matrix Num_Prod_CNAE[4,3] = r(p50)
matrix Num_Prod_CNAE[4,4] = r(max)

sum numprod if cnaefirm == 35, detail
matrix Num_Prod_CNAE[5,1] = 35
matrix Num_Prod_CNAE[5,2] = r(mean)
matrix Num_Prod_CNAE[5,3] = r(p50)
matrix Num_Prod_CNAE[5,4] = r(max)

sum numprod if cnaefirm == 34, detail
matrix Num_Prod_CNAE[6,1] = 34
matrix Num_Prod_CNAE[6,2] = r(mean)
matrix Num_Prod_CNAE[6,3] = r(p50)
matrix Num_Prod_CNAE[6,4] = r(max)

sum numprod if cnaefirm == 19, detail
matrix Num_Prod_CNAE[7,1] = 19
matrix Num_Prod_CNAE[7,2] = r(mean)
matrix Num_Prod_CNAE[7,3] = r(p50)
matrix Num_Prod_CNAE[7,4] = r(max)

sum numprod if cnaefirm == 21, detail
matrix Num_Prod_CNAE[8,1] = 21
matrix Num_Prod_CNAE[8,2] = r(mean)
matrix Num_Prod_CNAE[8,3] = r(p50)
matrix Num_Prod_CNAE[8,4] = r(max)

sum numprod if cnaefirm == 20, detail
matrix Num_Prod_CNAE[9,1] = 20
matrix Num_Prod_CNAE[9,2] = r(mean)
matrix Num_Prod_CNAE[9,3] = r(p50)
matrix Num_Prod_CNAE[9,4] = r(max)

sum numprod if cnaefirm == 32, detail
matrix Num_Prod_CNAE[10,1] = 32
matrix Num_Prod_CNAE[10,2] = r(mean)
matrix Num_Prod_CNAE[10,3] = r(p50)
matrix Num_Prod_CNAE[10,4] = r(max)

sum numprod, detail
matrix Num_Prod_CNAE[11,1] = 0
matrix Num_Prod_CNAE[11,2] = r(mean)
matrix Num_Prod_CNAE[11,3] = r(p50)
matrix Num_Prod_CNAE[11,4] = r(max)

svmat Num_Prod_CNAE

keep Num_Prod_CNAE*
drop if Num_Prod_CNAE1 == .

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results"

outsheet _all using Top10ExportInd, comma replace





clear

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"

use ExportValues

sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37

**** Keep only firm-destination pairs with more than 1 product ****
keep if numprod > 1

preserve

keep cnpj pais ncm year valueexpusd

**** Generate product ranking for each firm-destination-year triplet ****
gsort + cnpj + pais + year - valueexpusd
by cnpj pais year: gen ranking = _n

**** KEEP ONLY THE TWO MAIN PRODUCTS ****
keep if ranking <= 2

**** Compute the Ratios Value 1 / Value 2 ****
sort cnpj pais year
by cnpj pais year: gen ratio_value = valueexpusd / valueexpusd[_n+1]

keep if ranking == 1

sum ratio_value, detail

restore

gsort + cnpj + pais + year - valueexpusd
by cnpj pais year: gen ranking = _n
sort cnpj pais year

**** Dummy for not being the core product ****
gen not_core = (ranking > 1)

sort cnpj pais year not_core
by cnpj pais year not_core: egen valor2 = total(valueexpusd)

sort cnpj pais year
by cnpj pais year: gen ratio_value = valor2 / valor2[_n+1]

keep if ranking == 1

sum ratio_value, detail

log close

clear












******************
* Top Destinations
******************
clear

use ppp_brazil
sort year
save ppp_brazil, replace

use ExportValues

sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37

sort year
merge year using ppp_brazil
keep if _merge == 3
drop _merge
gen valueexpbrs = valueexpusd*xrat_bra / ppp_bra

keep valueexpbrs country_isocode

sort country_isocode
by country_isocode: egen tot_value = total(valueexpbrs)

keep country_isocode tot_value
duplicates drop
gsort - tot_value

egen totval = total(tot_value)
gen fraction = tot_value/totval






************************************
* # of Destinations
************************************
clear

use ExportValues

sort cnpj
merge cnpj using cnpj_cnae
keep if _merge == 3
drop _merge
destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37

keep cnpj pais year
duplicates drop

gen ones = 1

sort cnpj year
by cnpj year: egen dest = total(ones)

keep cnpj year dest
duplicates drop

sum dest, detail

