clear
set mem 700m


cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"

clear
use RER2
sort country_isocode year
save RER2, replace


clear
use cnpj_cnae9406
destring cnae, gen(cnaefirm)
rename cnpj8 cnpj
keep cnpj cnaefirm
sort cnpj cnaefirm
save cnpj_cnae, replace


use ppp_brazil
sort year
save ppp_brazil, replace


clear
use firms_lag
sort year
merge year using ppp_brazil
keep if _merge == 3
drop _merge
gen lag_imports = (lag_valorimpusd*xrat_bra) / (lag_wage*lag_emp*40*52)
replace lag_imports = 0 if lag_imports == .
gen lag_exports = (lag_valorexpusd*xrat_bra) / (lag_wage*lag_emp*40*52)
replace lag_exports = 0 if lag_exports == .
drop lag_valorimpusd lag_valorexpusd
sort cnpj year
save firms_lag_imp_exp, replace



clear

use ExportValues

sort cnpj 
merge cnpj using cnpj_cnae
keep if _merge == 1 | _merge == 3
drop _merge

sort country_isocode year
merge country_isocode year using RER2
keep if _merge == 1 | _merge == 3
drop _merge


sort cnpj year
merge cnpj year using firms_lag_imp_exp
keep if _merge == 1 | _merge == 3
drop _merge


destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
* drop if ncm <= 1000

egen gp1 = group(cnpj pais)

**** Keep only firm-destination pairs with more than 1 product ****
keep if numprod > 1

**** Attribute product ranking within a firm-destination-year combination ****
gsort + cnpj + pais + year -  valueexpusd
by cnpj pais year: gen ranking = _n

**** KEEP ONLY THE TWO MAIN PRODUCTS ****
keep if ranking <= 2

**** Compute the Ratios Value 1 / Value 2 ****
sort cnpj pais year
by cnpj pais year: gen ratio_value = valueexpusd / valueexpusd[_n+1]
gen log_ratio   = log(ratio_value)

keep if ranking == 1

gen t1 = year - 1997
gen t2 = (year - 1997)^2
gen t3 = (year - 1997)^3
gen t4 = (year - 1997)^4
gen t5 = (year - 1997)^5

gen log_rer         = log(rer)
gen log_lag_emp     = log(lag_emp)
gen log_cgdp        = log(cgdp)
gen log_gdp        = log(cgdp*pop)
gen log_lag_wage    = log(lag_wage)
gen log_lag_imports = log(1+lag_imports)
gen log_lag_exports = log(1+lag_exports)


gen log_rer_emp    = log_rer*log_lag_emp
gen log_rer_skill  = log_rer*lag_skill
gen log_rer_wage   = log_rer*log_lag_wage
gen log_rer_imp    = log_rer*log_lag_imports
gen log_rer_exp    = log_rer*log_lag_exports

display _N
sort cnpj pais year
merge cnpj pais year using IMRSkewness
keep if _merge == 3
drop _merge
drop ncm
duplicates drop
display _N

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results"

qui areg log_ratio log_rer t1 t2 t3 t4 t5 log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp IMR, absorb(gp1) vce(cluster cnpj)
qui outreg2 log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp IMR using SkewnessofSales_IMR, replace excel bdec(4) bracket ctitle("Value1/Value2")





************************************************************************************************************************************************ 
************************************************************************************************************************************************ 

clear

**********************************************
* Regress Value 1 / Sum(Value Rest) on Log RER
**********************************************

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"

clear

use ExportValues

sort cnpj 
merge cnpj using cnpj_cnae
keep if _merge == 1 | _merge == 3
drop _merge

sort country_isocode year
merge country_isocode year using RER2
keep if _merge == 1 | _merge == 3
drop _merge


sort cnpj year
merge cnpj year using firms_lag_imp_exp
keep if _merge == 1 | _merge == 3
drop _merge


destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
* drop if ncm <= 1000

egen gp1 = group(cnpj pais)


**** Keep only firm-destination pairs with more than 1 product ****
keep if numprod > 1

**** Generate product ranking for each firm-destination-year triplet ****
gsort + cnpj + pais + year -  valueexpusd
by cnpj pais year: gen ranking = _n
sort cnpj pais year

**** Dummy for not being the core product ****
gen not_core = (ranking > 1)

sort cnpj pais year not_core
by cnpj pais year not_core: egen valor2 = total(valueexpusd)

sort cnpj pais year
by cnpj pais year: gen ratio_value = valor2 / valor2[_n+1]
gen log_ratio   = log(ratio_value)

keep if ranking == 1

gen t1 = year - 1997
gen t2 = (year - 1997)^2
gen t3 = (year - 1997)^3
gen t4 = (year - 1997)^4
gen t5 = (year - 1997)^5


gen log_rer         = log(rer)
gen log_lag_emp     = log(lag_emp)
gen log_cgdp        = log(cgdp)
gen log_gdp         = log(cgdp*pop)
gen log_lag_wage    = log(lag_wage)
gen log_lag_imports = log(1+lag_imports)
gen log_lag_exports = log(1+lag_exports)


gen log_rer_emp    = log_rer*log_lag_emp
gen log_rer_skill  = log_rer*lag_skill
gen log_rer_wage   = log_rer*log_lag_wage
gen log_rer_imp    = log_rer*log_lag_imports
gen log_rer_exp    = log_rer*log_lag_exports

display _N
sort cnpj pais year
merge cnpj pais year using IMRSkewness
keep if _merge == 3
drop _merge
drop ncm
duplicates drop
display _N


cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results"

qui areg log_ratio log_rer t1 t2 t3 t4 t5 log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp IMR, absorb(gp1) vce(cluster cnpj)
qui outreg2 log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp IMR using SkewnessofSales_IMR, append excel bdec(4) bracket ctitle("Value1/ValueRest")





clear

**********************************************
* Herfindahl on Log RER
**********************************************

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data"

clear

use ExportValues

sort cnpj 
merge cnpj using cnpj_cnae
keep if _merge == 1 | _merge == 3
drop _merge

sort country_isocode year
merge country_isocode year using RER2
keep if _merge == 1 | _merge == 3
drop _merge


sort cnpj year
merge cnpj year using firms_lag_imp_exp
keep if _merge == 1 | _merge == 3
drop _merge


destring cnaeprod, replace
replace cnaeprod = cnaefirm if cnaeprod == .
* Keep only manufacturing
keep if cnaefirm >= 15 & cnaefirm <= 37
keep if cnaeprod >= 15 & cnaeprod <= 37
* drop if ncm <= 1000

egen gp1 = group(cnpj pais)

keep if numprod > 1

**** Generate product ranking for each firm-destination-year triplet ****
gsort + cnpj + pais + year - valueexpusd
by cnpj pais year: gen ranking = _n
sort cnpj pais year

sort cnpj pais year
by cnpj pais year: egen totalvalue = total(valueexpusd)
gen share = valueexpusd / totalvalue
gen share_2 = share^2
by cnpj pais year: egen herfindahl = total(share_2)

keep if ranking == 1

gen t1 = year - 1997
gen t2 = (year - 1997)^2
gen t3 = (year - 1997)^3
gen t4 = (year - 1997)^4
gen t5 = (year - 1997)^5


gen log_rer         = log(rer)
gen log_lag_emp     = log(lag_emp)
gen log_cgdp        = log(cgdp)
gen log_gdp         = log(cgdp*pop)
gen log_lag_wage    = log(lag_wage)
gen log_lag_imports = log(1+lag_imports)
gen log_lag_exports = log(1+lag_exports)


gen log_rer_emp    = log_rer*log_lag_emp
gen log_rer_skill  = log_rer*lag_skill
gen log_rer_wage   = log_rer*log_lag_wage
gen log_rer_imp    = log_rer*log_lag_imports
gen log_rer_exp    = log_rer*log_lag_exports


display _N
sort cnpj pais year
merge cnpj pais year using IMRSkewness
keep if _merge == 3
drop _merge
drop ncm
duplicates drop
display _N

drop if herfindahl == 1 | herfindahl == 0

cd "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Results"

qui areg herfindahl log_rer t1 t2 t3 t4 t5 log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp IMR, absorb(gp1) vce(cluster cnpj)
qui outreg2 log_rer log_lag_emp log_lag_wage lag_skill log_lag_imports log_lag_exports log_cgdp log_gdp IMR using SkewnessofSales_IMR, append excel bdec(4) bracket ctitle("Herfindahl")
