/*** LIBRARY PATHS ***/
libname imp 'C:\Data\SECEX\Bases\Importacao';
libname exp 'C:\Data\SECEX\Bases\Exportacao';
libname datalib 'C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data' ;




data lag_active97 (keep = cnpj pais ncm year lag_active97) ;
	set exp.exp96 ;
	cnpj = cnpj8 ;
	lag_active97 = 1 ;
	year = ano + 1 ;
run ;

proc sort data = lag_active97 nodupkey ; by cnpj pais ncm year; run ;

PROC EXPORT DATA = lag_active97 
	OUTFILE= "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data\lag_active97.dta" 
    DBMS=DTA REPLACE;
RUN;


data lag_multi97 (keep = cnpj pais ncm year ones) ;
	set exp.exp96 ;
	cnpj = cnpj8 ;
	year = ano + 1 ;
	ones = 1 ;
run ;

proc sort data = lag_multi97 ; by cnpj pais year; run ;

proc means data = lag_multi97 noprint ;
	var ones ;
   	by cnpj pais year ;
   	output out = lag_multi97 (drop = _type_ _freq_)
	sum = num_prod ;
run;

proc sort data = lag_multi97 nodupkeys ; by cnpj pais year num_prod; run ;

data lag_multi97 ;
	set lag_multi97 ;	
	lag_multi97 = (num_prod > 1) ;
run ;


PROC EXPORT DATA = lag_multi97 
	OUTFILE= "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data\lag_multi97.dta" 
    DBMS=DTA REPLACE;
RUN;


/**********************************************/

%macro Aggregate(start = , stop = ) ;

	%do t = &start %to &stop ;

		%let s = %substr(&t,3,2) ;

		data imp&s. ;
			set imp.imp&s. ;
		run ;

		proc sort data = imp&s. ; by cnpj8 ano ; run ;

		proc means data = imp&s. noprint ;
			var valor ;
   			by cnpj8 ano ;
   			output out = Imp&s.Agg (drop = _type_ _freq_)
			sum = ValorImpUSD ;
		run;

	%end;
%mend;

%Aggregate(start=1996,stop=2000) ;
%Aggregate(start=2002,stop=2006) ;


data imp01 ;
	set imp.imp01_original ;
run ;

proc sort data = imp01 ; by cnpj8 ano ; run ;

proc means data = imp01 noprint ;
	var valor ;
	by cnpj8 ano ;
	output out = Imp01Agg (drop = _type_ _freq_)
	sum = ValorImpUSD ;
run;


data datalib.Imports (drop = ano cnpj8) ;
	set imp96Agg imp97Agg imp98Agg imp99Agg imp00Agg imp01Agg 
        imp02Agg imp03Agg imp04Agg imp05Agg imp06Agg ;
	year = input(ano,5.) ;
	cnpj = cnpj8 ;
run ;


data Imports96 ;
	set datalib.Imports ;
	if year = 1997 ;
	year = 1996 ;
run ;

data datalib.Imports ;
	set datalib.Imports Imports96 ;
run ;



%macro Aggregate2(start = , stop = ) ;

	%do t = &start %to &stop ;

		%let s = %substr(&t,3,2) ;

		data exp&s. ;
			set exp.exp&s. ;
		run ;

		proc sort data = exp&s. ; by cnpj8 ano ; run ;

		proc means data = exp&s. noprint ;
			var valor ;
   			by cnpj8 ano ;
   			output out = exp&s.Agg (drop = _type_ _freq_)
			sum = ValorExpUSD ;
		run;

	%end;
%mend;

%Aggregate2(start=1996,stop=2006) ;


data datalib.exports (drop = ano cnpj8) ;
	set exp96Agg exp97Agg exp98Agg exp99Agg exp00Agg exp01Agg 
        exp02Agg exp03Agg exp04Agg exp05Agg exp06Agg ;
	year = input(ano,5.) ;
	cnpj = cnpj8 ;
run ;








%macro NumProd(start = , stop = ) ;

	%do t = &start %to &stop ;

		%let s = %substr(&t,3,2) ;

		data exp&s. (keep = cnpj8 ncm ano ones) ;
			set exp.exp&s. ;
			ones = 1 ;
		run ;

		proc sort data = exp&s. nodupkey; by cnpj8 ano ncm ; run ;

		proc means data = exp&s. noprint ;
			var ones ;
   			by cnpj8 ano ;
   			output out = NumProd&s. (drop = _type_ _freq_)
			sum = NumProd ;
		run;

	%end;
%mend;

%NumProd(start=1996,stop=2006) ;


data datalib.NumProd (drop = ano cnpj8) ;
	set NumProd96 NumProd97 NumProd98 NumProd99 NumProd00 NumProd01
	    NumProd02 NumProd03 NumProd04 NumProd05 NumProd06 ;
	year = input(ano,5.) ;
	cnpj = cnpj8 ;
run ;



















%macro NDest(start = , stop = ) ;

	%do t = &start %to &stop ;

		%let s = %substr(&t,3,2) ;

		data exp&s. (keep = cnpj8 pais ano ones) ;
			set exp.exp&s. ;
			ones = 1 ;
		run ;

		proc sort data = exp&s. nodupkey; by cnpj8 ano pais ; run ;

		proc means data = exp&s. noprint ;
			var ones ;
   			by cnpj8 ano ;
   			output out = NDest&s. (drop = _type_ _freq_)
			sum = NDest ;
		run;

	%end;
%mend;

%NDest(start=1996,stop=2006) ;


data datalib.NDest (drop = ano cnpj8) ;
	set NDest96 NDest97 NDest98 NDest99 NDest00 NDest01
	    NDest02 NDest03 NDest04 NDest05 NDest06 ;
	year = input(ano,5.) ;
	cnpj = cnpj8 ;
run ;
