/*** LIBRARY PATHS ***/
libname imp 'C:\Data\SECEX\Bases\Importacao';
libname exp 'C:\Data\SECEX\Bases\Exportacao';
libname datalib 'C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data' ;
libname corr 'C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Correspondance' ;
libname pwt "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\PWT" ;


proc sort data = corr.ncm9602_final ; by ncm1996 ; run ;

%macro Aggregate1(start = , stop = ) ;

	%do t = &start %to &stop ;

		%let s = %substr(&t,3,2) ;

		data exp&s. (drop = ncm) ;
			set exp.exp&s. ;
			ncm1996 = input(ncm,8.) ;
		run ;

		proc sort data = exp&s. ; by ncm1996 ; run ;

		data exp&s. ;
			merge exp&s. (in = a) corr.ncm9602_final ;
			by ncm1996 ;
			if a ;
			if group96 = . then ncm = ncm1996 ;
			if group96 ~= . then ncm = group96 ;
		run ;

		proc sort data = exp&s. nodupkeys ; by cnpj8 pais ncm ano ; run ;

		proc means data = exp&s. noprint ;
			var valor ;
   			by cnpj8 pais ncm ano ;
   			output out = exp&s.Agg (drop = _type_ _freq_)
			sum = ValueExpUSD ;
		run;

	%end;
%mend;

%Aggregate1(start=1996,stop=2001) ;


data exp00 (drop = ncm) ;
	set exp.exp00_original ;
	ncm1996 = input(ncm,8.) ;
run ;

proc sort data = exp00 ; by ncm1996 ; run ;

data exp00 ;
	merge exp00 (in = a) corr.ncm9602_final ;
	by ncm1996 ;
	if a ;
	if group96 = . then ncm = ncm1996 ;
	if group96 ~= . then ncm = group96 ;
run ;

proc sort data = exp00 nodupkeys ; by cnpj8 pais ncm ano ; run ;

proc means data = exp00 noprint ;
	var valor ;
	by cnpj8 pais ncm ano ;
	output out = exp00Agg (drop = _type_ _freq_)
	sum = ValueExpUSD ;
run;



proc sort data = corr.ncm9602_final ; by ncm2002 ; run ;

%macro Aggregate2(start = , stop = ) ;

	%do t = &start %to &stop ;

		%let s = %substr(&t,3,2) ;

		data exp&s. (drop = ncm) ;
			set exp.exp&s. ;
			ncm2002 = input(ncm,8.) ;
		run ;

		proc sort data = exp&s. ; by ncm2002 ; run ;

		data exp&s. ;
			merge exp&s. (in = a) corr.ncm9602_final ;
			by ncm2002 ;
			if a ;
			if group96 = . then ncm = ncm2002 ;
			if group96 ~= . then ncm = group96 ;
		run ;

		proc sort data = exp&s. nodupkeys ; by cnpj8 pais ncm ano ; run ;

		proc means data = exp&s. noprint ;
			var valor ;
   			by cnpj8 pais ncm ano ;
   			output out = exp&s.Agg (drop = _type_ _freq_)
			sum = ValueExpUSD ;
		run;

	%end;
%mend;

%Aggregate2(start=2002,stop=2006) ;


data datalib.ExportValues (drop = ano cnpj8 cnaeprod) ;
	set exp96Agg exp97Agg exp98Agg exp99Agg exp00Agg exp01Agg 
        exp02Agg exp03Agg exp04Agg exp05Agg exp06Agg ;
	year = input(ano,5.) ;
	cnpj = cnpj8 ;
	ones = 1 ;
run ;

proc sort data = datalib.ExportValues nodupkeys ; by cnpj pais year ncm ; run ;

proc means data = datalib.ExportValues noprint ;
	var ones ;
	by cnpj pais year ;
	output out = NumberProducts (drop = _type_ _freq_)
	sum = NumProd ;
run;

proc sort data = NumberProducts nodupkeys ; by cnpj pais year NumProd ; run ;

proc sort data = datalib.ExportValues ; by cnpj pais year ; run ;
proc sort data = NumberProducts ; by cnpj pais year ; run ;

data datalib.ExportValues (drop = ones) ;
	merge datalib.ExportValues (in = a) NumberProducts ;
	by cnpj pais year ;
	if a ;
run ;




data ncm1996cnae (keep = ncm cnae1996) ;
	set corr.ncm1996cnae ;
	ncm = input(ncm1996,8.) ;
	cnae1996 = cnae2 ;
run ;

data ncm2002cnae (keep = ncm cnae2002) ;
	set corr.ncm2002cnae ;
	ncm = input(ncm2002,8.) ;
	cnae2002 = cnae2 ;
run ;

proc sort data = ncm1996cnae ; by ncm ; run ;

proc sort data = ncm2002cnae ; by ncm ; run ;

proc sort data = datalib.ExportValues ; by ncm ; run ;

data datalib.ExportValues (drop = cnae2002 cnae1996) ;
	merge datalib.ExportValues (in = a) ncm1996cnae ncm2002cnae ;
	by ncm ;
	if a ;
	cnaeprod = cnae1996 ;
	if cnae1996 = "" then cnaeprod = cnae2002 ;
run ;


proc sort data = pwt.PWT_Secex ; by pais ; run ;
proc sort data = datalib.ExportValues ; by pais ; run ;

data datalib.ExportValues ; 
	merge datalib.ExportValues (in = a) pwt.PWT_Secex ;
	by pais ;
	if a ;
run ;

proc sort data = corr.group96_cnae2 ; by ncm ; run ;
proc sort data = datalib.ExportValues ; by ncm ; run ;

data datalib.ExportValues (drop = group96 cnae2) ;
	merge datalib.ExportValues (in = a) corr.group96_cnae2 ;
	by ncm ;
	if a ;
	if ncm <= 1000 then cnaeprod = cnae2 ;
run ;


PROC EXPORT DATA = datalib.ExportValues 
	OUTFILE= "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data\ExportValues.dta" 
    DBMS=DTA REPLACE;
RUN;



