libname datalib 'C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data';



data firms (keep = cnpj year total_emp avg_wage fraction_skilled cnae) ;
	set datalib.firms ;
run ;


proc sort data = firms ; by cnpj year ; run ;

proc sort data = datalib.imports ; by cnpj year ; run ;
proc sort data = datalib.exports ; by cnpj year ; run ;
proc sort data = datalib.NumProd ; by cnpj year ; run ;
proc sort data = datalib.NDest ; by cnpj year ; run ;

data firms ;
	merge firms (in = a) datalib.imports datalib.exports datalib.NumProd datalib.NDest;
	by cnpj year ;
	if a ;
run ;

data firms_lag (keep = cnpj year lag_emp lag_wage lag_skill lag_ValorImpUSD lag_ValorExpUSD lag_NumProd lag_NDest) ;
	set firms ;

	year = year + 1 ;
	lag_emp = total_emp ;
	lag_wage = avg_wage ;
	lag_skill = fraction_skilled ;
	lag_ValorImpUSD = ValorImpUSD ;
	lag_ValorExpUSD = ValorExpUSD ;
	lag_NumProd = NumProd ;
	lag_NDest = NDest ;

run ;


proc sort data = firms ; by cnpj year ; run ;

proc sort data = firms_lag ; by cnpj year ; run ;


data firms ;
	merge firms (in = a) firms_lag ;
	by cnpj year ;
	if a ;
run ;


proc sort data = firms ; by cnpj year ; run ;


proc sort data = datalib.UnitValues ; by cnpj year ; run ;

data datalib.UnitValues_Firms ;
	merge datalib.UnitValues (in = a) firms ;
	by cnpj year ;
	if a ;
run ;



data datalib.firms_lag (keep = cnpj year lag_emp lag_wage lag_skill lag_ValorImpUSD lag_ValorExpUSD lag_NumProd lag_NDest) ;
	set firms_lag ;
	if year >= 1997 and year <= 2006 ;
run ;


PROC EXPORT DATA = datalib.firms_lag 
	OUTFILE= "C:\Users\Dix-Carneiro\Documents\Exchange Rates & Multi-Product Firms\Data\firms_lag.dta" 
    DBMS=DTA REPLACE;
RUN;
